Get list of Environments

GET /apprapp/feature/v1/instances/{guid}/environments

List all the environments in the App Configuration service instance.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.environments.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.environments.list

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

Query Parameters

expand

boolean

If set to `true`, returns expanded view of the resource details.

sort

string

Sort the environment details based on the specified attribute. By default, items are sorted by name.

tags

string

Filter the resources to be returned based on the associated tags. Specify the parameter as a list of comma separated tags. Returns resources associated with any of the specified tags.

include

array

Include feature, property, snapshots details in the response.

limit

integer

The number of records to retrieve. By default, the list operation return the first 10 records. To retrieve different set of records, use `limit` with `offset` to page through the available records.

offset

integer

The number of records to skip. By specifying `offset`, you retrieve a subset of items that starts with the `offset` value. Use `offset` with `limit` to page through the available records.

string

Searches for the provided keyword and returns the appropriate row with that value. Here the search happens on the '[Name OR Tag]' of the entity

Response

200 - Successfully listed the environments.

environments

array

Array of environments.

limit

integer

The number of records that are retrieved in a list.

offset

integer

The number of records that are skipped in a list.

total_count

integer

The total number of records.

first

PaginatedListFirst

URL to navigate to the first page of records.

previous

PaginatedListPrevious

URL to navigate to the previous list of records.

next

PaginatedListNext

URL to navigate to the next list of records.

last

PaginatedListLast

URL to navigate to the last page of records.

401 - Unauthorized

message

string

The message describing the error.

Create Environment

POST /apprapp/feature/v1/instances/{guid}/environments

Create an environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.environments.create

Auditing

Calling this method generates the following auditing event.

  • apprapp.environments.create

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

Query Parameters

Response

201 - Successfully created the environment.

name

string

Environment name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

environment_id

string

Environment id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Environment description

tags

string

Tags associated with the environment, allowed special characters are [_. ,-:]

color_code

string

Color code to distinguish the environment. The Hex code for the color. For example `#FF0000` for `red`.

created_time

string

Creation time of the environment.

updated_time

string

Last modified time of the environment data.

href

string

Environment URL

features

array

List of Features associated with the environment.

properties

array

List of properties associated with the environment.

snapshots

array

List of snapshots associated with the environment.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Update Environment

PUT /apprapp/feature/v1/instances/{guid}/environments/{environment_id}

Update an environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.environments.update

Auditing

Calling this method generates the following auditing event.

  • apprapp.environments.update

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

Query Parameters

Response

200 - Successfully updated the environment details.

name

string

Environment name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

environment_id

string

Environment id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Environment description

tags

string

Tags associated with the environment, allowed special characters are [_. ,-:]

color_code

string

Color code to distinguish the environment. The Hex code for the color. For example `#FF0000` for `red`.

created_time

string

Creation time of the environment.

updated_time

string

Last modified time of the environment data.

href

string

Environment URL

features

array

List of Features associated with the environment.

properties

array

List of properties associated with the environment.

snapshots

array

List of snapshots associated with the environment.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the environment id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get Environment

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}

Retrieve the details of the environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.environments.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.environments.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

Query Parameters

expand

boolean

If set to `true`, returns expanded view of the resource details.

include

array

Include feature, property, snapshots details in the response.

Response

200 - Successfully retrieved the environment details.

name

string

Environment name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

environment_id

string

Environment id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Environment description

tags

string

Tags associated with the environment, allowed special characters are [_. ,-:]

color_code

string

Color code to distinguish the environment. The Hex code for the color. For example `#FF0000` for `red`.

created_time

string

Creation time of the environment.

updated_time

string

Last modified time of the environment data.

href

string

Environment URL

features

array

List of Features associated with the environment.

properties

array

List of properties associated with the environment.

snapshots

array

List of snapshots associated with the environment.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

404 - Not Found. Verify that the environment id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Delete Environment

DELETE /apprapp/feature/v1/instances/{guid}/environments/{environment_id}

Delete an Environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.environments.delete

Auditing

Calling this method generates the following auditing event.

  • apprapp.environments.delete

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

Query Parameters

Response

202 - Accepted. Workflow approval initiated for the environment delete operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

204 - Successfully deleted the specified environment.

400 - Bad request. Ensure that at least one environment should exist in the instance.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the environment id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Environment delete operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

Get list of Collections

GET /apprapp/feature/v1/instances/{guid}/collections

List of all the collections in the App Configuration service instance.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.collections.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.collections.list

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

Query Parameters

expand

boolean

If set to `true`, returns expanded view of the resource details.

sort

string

Sort the collection details based on the specified attribute. By default, items are sorted by name.

tags

string

Filter the resources to be returned based on the associated tags. Specify the parameter as a list of comma separated tags. Returns resources associated with any of the specified tags.

features

array

Filter collections by a list of comma separated features.

properties

array

Filter collections by a list of comma separated properties.

include

array

Include feature, property, snapshots details in the response.

limit

integer

The number of records to retrieve. By default, the list operation return the first 10 records. To retrieve different set of records, use `limit` with `offset` to page through the available records.

offset

integer

The number of records to skip. By specifying `offset`, you retrieve a subset of items that starts with the `offset` value. Use `offset` with `limit` to page through the available records.

search

string

Searches for the provided keyword and returns the appropriate row with that value. Here the search happens on the '[Name OR Tag]' of the entity

Response

200 - Successfully listed the collections.

collections

array

Array of collections.

limit

integer

The number of records that are retrieved in a list.

offset

integer

The number of records that are skipped in a list.

total_count

integer

The total number of records.

first

PaginatedListFirst

URL to navigate to the first page of records.

previous

PaginatedListPrevious

URL to navigate to the previous list of records.

next

PaginatedListNext

URL to navigate to the next list of records.

last

PaginatedListLast

URL to navigate to the last page of records.

401 - Unauthorized

message

string

The message describing the error.

Create Collection

POST /apprapp/feature/v1/instances/{guid}/collections

Create a collection.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.collections.create

Auditing

Calling this method generates the following auditing event.

  • apprapp.collections.create

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

Query Parameters

Response

201 - Successfully created the collection.

name

string

Collection name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

collection_id

string

Collection Id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Collection description

tags

string

Tags associated with the collection, allowed special characters are [_. ,-:]

created_time

string

Creation time of the collection.

updated_time

string

Last updated time of the collection data.

href

string

Collection URL

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Update Collection

PUT /apprapp/feature/v1/instances/{guid}/collections/{collection_id}

Update the collection name, tags and description. Collection Id cannot be updated.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.collections.update

Auditing

Calling this method generates the following auditing event.

  • apprapp.collections.update

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

collection_id

Required *

string

Collection Id of the collection

Query Parameters

Response

200 - Successfully updated the collection details.

name

string

Collection name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

collection_id

string

Collection Id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Collection description

tags

string

Tags associated with the collection, allowed special characters are [_. ,-:]

created_time

string

Creation time of the collection.

updated_time

string

Last updated time of the collection data.

href

string

Collection URL

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the collection id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get Collection

GET /apprapp/feature/v1/instances/{guid}/collections/{collection_id}

Retrieve the details of the collection.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.collections.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.collections.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

collection_id

Required *

string

Collection Id of the collection

Query Parameters

expand

boolean

If set to `true`, returns expanded view of the resource details.

include

array

Include feature, property, snapshots details in the response.

Response

200 - Successfully retrieved the collection details.

name

string

Collection name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

collection_id

string

Collection Id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Collection description

tags

string

Tags associated with the collection, allowed special characters are [_. ,-:]

created_time

string

Creation time of the collection.

updated_time

string

Last updated time of the collection data.

href

string

Collection URL

features

array

List of Features associated with the collection.

properties

array

List of properties associated with the collection.

snapshots

array

List of snapshots associated with the collection.

features_count

integer

Number of features associated with the collection.

properties_count

integer

Number of properties associated with the collection.

snapshot_count

integer

Number of snapshot associated with the collection.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

404 - Not Found. Verify that the collection id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Delete Collection

DELETE /apprapp/feature/v1/instances/{guid}/collections/{collection_id}

Delete the collection.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.collections.delete

Auditing

Calling this method generates the following auditing event.

  • apprapp.collections.delete

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

collection_id

Required *

string

Collection Id of the collection

Query Parameters

Response

202 - Accepted. Workflow approval initiated for the collection delete operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

204 - Successfully deleted the specified collection.

404 - Not Found. Verify that the collection id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Collection delete operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

Get list of Features

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features

List all the feature flags in the specified environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.list

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

Query Parameters

expand

boolean

If set to `true`, returns expanded view of the resource details.

sort

string

Sort the feature details based on the specified attribute. By default, items are sorted by name.

tags

string

Filter the resources to be returned based on the associated tags. Specify the parameter as a list of comma separated tags. Returns resources associated with any of the specified tags.

collections

array

Filter features by a list of comma separated collections.

segments

array

Filter features by a list of comma separated segments.

include

array

Include the associated collections or targeting rules or change request details in the response.

limit

integer

The number of records to retrieve. By default, the list operation return the first 10 records. To retrieve different set of records, use `limit` with `offset` to page through the available records.

offset

integer

The number of records to skip. By specifying `offset`, you retrieve a subset of items that starts with the `offset` value. Use `offset` with `limit` to page through the available records.

search

string

Searches for the provided keyword and returns the appropriate row with that value. Here the search happens on the '[Name OR Tag]' of the entity

Response

200 - Successfully listed all the features.

features

array

Array of Features.

limit

integer

The number of records that are retrieved in a list.

offset

integer

The number of records that are skipped in a list.

total_count

integer

The total number of records.

first

PaginatedListFirst

URL to navigate to the first page of records.

previous

PaginatedListPrevious

URL to navigate to the previous list of records.

next

PaginatedListNext

URL to navigate to the next list of records.

last

PaginatedListLast

URL to navigate to the last page of records.

401 - Unauthorized

message

string

The message describing the error.

Create Feature

POST /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features

Create a feature flag

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features.create

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.create

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

Query Parameters

Response

201 - Successfully created the feature flag.

name

string

Feature name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

feature_id

string

Feature id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Feature description

type

string

Type of the feature (BOOLEAN, STRING, NUMERIC). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the feature (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN` and `NUMERIC` types. This property is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN` and `NUMERIC` types.

enabled_value

object

Value of the feature when it is enabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

disabled_value

object

Value of the feature when it is disabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

enabled

boolean

The state of the feature flag.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

tags

string

Tags associated with the feature, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different feature flag values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the feature flag.

segment_count

integer

The number of targeting rules (segment_rules) configured for the feature flag.

rollout_rule

RolloutRule

Identifies which rule of the feature flag is currently under a Progressive rollout. Only one rule among set-of-rules can be under rollout at a time.

collections

array

List of collection id representing the collections that are associated with the specified feature flag.

created_time

string

Creation time of the feature flag.

updated_time

string

Last modified time of the feature flag data.

evaluation_time

string

The last occurrence of the feature flag value evaluation.

href

string

Feature flag URL

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

400 - Bad request. . Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Update Feature

PUT /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}

Update a feature flag details

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features.update

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.update

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

200 - Successfully updated the feature flag details

name

string

Feature name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

feature_id

string

Feature id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Feature description

type

string

Type of the feature (BOOLEAN, STRING, NUMERIC). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the feature (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN` and `NUMERIC` types. This property is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN` and `NUMERIC` types.

enabled_value

object

Value of the feature when it is enabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

disabled_value

object

Value of the feature when it is disabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

enabled

boolean

The state of the feature flag.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

tags

string

Tags associated with the feature, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different feature flag values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the feature flag.

segment_count

integer

The number of targeting rules (segment_rules) configured for the feature flag.

rollout_rule

RolloutRule

Identifies which rule of the feature flag is currently under a Progressive rollout. Only one rule among set-of-rules can be under rollout at a time.

collections

array

List of collection id representing the collections that are associated with the specified feature flag.

created_time

string

Creation time of the feature flag.

updated_time

string

Last modified time of the feature flag data.

evaluation_time

string

The last occurrence of the feature flag value evaluation.

href

string

Feature flag URL

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

202 - Accepted. Workflow approval initiated for the feature update operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature update operation is already under workflow approval, or the update is blocked because the feature's collection association is being changed from an environment that is not scoped for workflow, while another environment in the instance has an active workflow scope for this feature.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Update Feature Values

PATCH /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}

Update the feature values. This method can be executed only by the `writer` role. This method allows the update of feature name, feature enabled_value, feature disabled_value, tags, description and feature segment rules, however this method does not allow toggling the feature flag and assigning feature to a collection.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features.patch

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.updatevalues

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

200 - Successfully updated the feature values.

name

string

Feature name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

feature_id

string

Feature id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Feature description

type

string

Type of the feature (BOOLEAN, STRING, NUMERIC). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the feature (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN` and `NUMERIC` types. This property is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN` and `NUMERIC` types.

enabled_value

object

Value of the feature when it is enabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

disabled_value

object

Value of the feature when it is disabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

enabled

boolean

The state of the feature flag.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

tags

string

Tags associated with the feature, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different feature flag values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the feature flag.

segment_count

integer

The number of targeting rules (segment_rules) configured for the feature flag.

rollout_rule

RolloutRule

Identifies which rule of the feature flag is currently under a Progressive rollout. Only one rule among set-of-rules can be under rollout at a time.

collections

array

List of collection id representing the collections that are associated with the specified feature flag.

created_time

string

Creation time of the feature flag.

updated_time

string

Last modified time of the feature flag data.

evaluation_time

string

The last occurrence of the feature flag value evaluation.

href

string

Feature flag URL

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

202 - Accepted. Workflow approval initiated for the feature patch operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature patch operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get Feature

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}

Retrieve details of a feature.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

include

array

Include the associated collections or targeting rules or change request details in the response.

Response

200 - Successfully retrieved the feature details.

name

string

Feature name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

feature_id

string

Feature id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Feature description

type

string

Type of the feature (BOOLEAN, STRING, NUMERIC). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the feature (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN` and `NUMERIC` types. This property is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN` and `NUMERIC` types.

enabled_value

object

Value of the feature when it is enabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

disabled_value

object

Value of the feature when it is disabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

enabled

boolean

The state of the feature flag.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

tags

string

Tags associated with the feature, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different feature flag values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the feature flag.

segment_count

integer

The number of targeting rules (segment_rules) configured for the feature flag.

rollout_rule

RolloutRule

Identifies which rule of the feature flag is currently under a Progressive rollout. Only one rule among set-of-rules can be under rollout at a time.

collections

array

List of collection id representing the collections that are associated with the specified feature flag.

created_time

string

Creation time of the feature flag.

updated_time

string

Last modified time of the feature flag data.

evaluation_time

string

The last occurrence of the feature flag value evaluation.

href

string

Feature flag URL

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Delete Feature

DELETE /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}

Delete a feature flag

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features.delete

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.delete

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

202 - Accepted. Workflow approval initiated for the feature delete operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

204 - Successfully deleted the specified feature.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature delete operation is already under workflow approval, or the delete is blocked because the feature is being deleted from an environment that is not scoped for workflow, while another environment in the instance has an active workflow scope for this feature.

Toggle Feature

PUT /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/toggle

Toggle a feature.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features.toggle

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.toggle

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

200 - Successfully toggled the specified feature.

name

string

Feature name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

feature_id

string

Feature id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Feature description

type

string

Type of the feature (BOOLEAN, STRING, NUMERIC). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the feature (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN` and `NUMERIC` types. This property is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN` and `NUMERIC` types.

enabled_value

object

Value of the feature when it is enabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

disabled_value

object

Value of the feature when it is disabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

enabled

boolean

The state of the feature flag.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

tags

string

Tags associated with the feature, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different feature flag values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the feature flag.

segment_count

integer

The number of targeting rules (segment_rules) configured for the feature flag.

rollout_rule

RolloutRule

Identifies which rule of the feature flag is currently under a Progressive rollout. Only one rule among set-of-rules can be under rollout at a time.

collections

array

List of collection id representing the collections that are associated with the specified feature flag.

created_time

string

Creation time of the feature flag.

updated_time

string

Last modified time of the feature flag data.

evaluation_time

string

The last occurrence of the feature flag value evaluation.

href

string

Feature flag URL

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

202 - Accepted. Workflow approval initiated for the feature toggle operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature toggle operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

Stop Feature Rollout

PATCH /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rollout

Stop an in-progress rollout for a feature flag that is in a Progressive rollout state. The rollout is halted at the specified rollout percentage, which becomes the fixed percentage at which the feature is served until the rollout is reconfigured. This operation is not applicable to features in Manual rollout mode.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rollout-action.patch

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.update

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

200 - Successfully stopped the in-progress rollout.

name

string

Feature name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

feature_id

string

Feature id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Feature description

type

string

Type of the feature (BOOLEAN, STRING, NUMERIC). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the feature (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN` and `NUMERIC` types. This property is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN` and `NUMERIC` types.

enabled_value

object

Value of the feature when it is enabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

disabled_value

object

Value of the feature when it is disabled. The value can be Boolean, Numeric, String - TEXT, String - JSON, String - YAML value as per the `type` and `format` attributes.

enabled

boolean

The state of the feature flag.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

tags

string

Tags associated with the feature, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different feature flag values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the feature flag.

segment_count

integer

The number of targeting rules (segment_rules) configured for the feature flag.

rollout_rule

RolloutRule

Identifies which rule of the feature flag is currently under a Progressive rollout. Only one rule among set-of-rules can be under rollout at a time.

collections

array

List of collection id representing the collections that are associated with the specified feature flag.

created_time

string

Creation time of the feature flag.

updated_time

string

Last modified time of the feature flag data.

evaluation_time

string

The last occurrence of the feature flag value evaluation.

href

string

Feature flag URL

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

202 - Accepted. Workflow approval initiated for stopping the feature rollout operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature stop rollout operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

Create Feature Rule

POST /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rules

Create a rule for feature flag

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rules.create

Auditing

Calling this method generates the following auditing event.

  • apprapp.features-rules.create

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

201 - Successfully created the feature rule.

rules

array

The list of targeted segments.

value

object

Value to be used for evaluation for this rule. The value can be Boolean, SecretRef, String - TEXT , String - JSON , String - YAML or a Numeric value as per the `type` and `format` attributes.

rule_id

string

Rule id is an identifier used for identifying the rule

rule_name

string

Name assigned to a particular rule.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

order

integer

Order of the rule, used during evaluation. The evaluation is performed in the order defined and the value associated with the first matching rule is used for evaluation.

href

string

Feature flag rule URL

202 - Accepted. Workflow approval initiated for the feature rule create operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request. . Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature rule create operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get All rules for feature

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rules

Get all the rules for a feature flag in the specified environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rules.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.features-rules.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

200 - Successfully fetched the targeted rules.

segment_rules

array

Array of Segment Rules

limit

integer

The number of records that are retrieved in a list.

offset

integer

The number of records that are skipped in a list.

total_count

integer

The total number of records.

first

PaginatedListFirst

URL to navigate to the first page of records.

previous

PaginatedListPrevious

URL to navigate to the previous list of records.

next

PaginatedListNext

URL to navigate to the next list of records.

last

PaginatedListLast

URL to navigate to the last page of records.

401 - Unauthorized

message

string

The message describing the error.

Get rule for feature by rule id

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rules/{rule_id}

Get the rule by rule id for the feature flag in the specified environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rules.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.features-rules.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

rule_id

Required *

string

rule id

Query Parameters

Response

200 - Successfully fetched the rule.

rules

array

The list of targeted segments.

value

object

Value to be used for evaluation for this rule. The value can be Boolean, SecretRef, String - TEXT , String - JSON , String - YAML or a Numeric value as per the `type` and `format` attributes.

rule_id

string

Rule id is an identifier used for identifying the rule

rule_name

string

Name assigned to a particular rule.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

order

integer

Order of the rule, used during evaluation. The evaluation is performed in the order defined and the value associated with the first matching rule is used for evaluation.

href

string

Feature flag rule URL

401 - Unauthorized

message

string

The message describing the error.

Update Feature rule

PATCH /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rules/{rule_id}

Update Feature rule.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rule.patch

Auditing

Calling this method generates the following auditing event.

  • apprapp.features-rule.patch

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

rule_id

Required *

string

rule id

Query Parameters

Response

200 - Successfully update the specified feature rule.

rules

array

The list of targeted segments.

value

object

Value to be used for evaluation for this rule. The value can be Boolean, SecretRef, String - TEXT , String - JSON , String - YAML or a Numeric value as per the `type` and `format` attributes.

rule_id

string

Rule id is an identifier used for identifying the rule

rule_name

string

Name assigned to a particular rule.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

order

integer

Order of the rule, used during evaluation. The evaluation is performed in the order defined and the value associated with the first matching rule is used for evaluation.

href

string

Feature flag rule URL

202 - Accepted. Workflow approval initiated for the feature rule patch operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict occurred

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

Delete Feature rule

DELETE /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rules/{rule_id}

Delete a feature rule

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rules.delete

Auditing

Calling this method generates the following auditing event.

  • apprapp.features-rules.delete

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

rule_id

Required *

string

rule id

Query Parameters

Response

202 - Accepted. Workflow approval initiated for the feature rule delete operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

204 - Successfully deleted the specified rule.

404 - Not Found. Verify that the rule id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature rule delete operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

Stop Feature Rule Rollout

PATCH /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rules/{rule_id}/rollout

Stop an in-progress rollout for a specific rule of a feature flag that is in a Progressive rollout state. The rollout for the rule is halted at the specified rollout percentage, which becomes the fixed percentage at which the rule is evaluated until the rollout is reconfigured. This operation is not applicable to rules that are in Manual rollout mode.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rules-rollout-action.patch

Auditing

Calling this method generates the following auditing event.

  • apprapp.features.update

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

rule_id

Required *

string

rule id

Query Parameters

Response

200 - Successfully stopped the in-progress rollout for specified rule.

rules

array

The list of targeted segments.

value

object

Value to be used for evaluation for this rule. The value can be Boolean, SecretRef, String - TEXT , String - JSON , String - YAML or a Numeric value as per the `type` and `format` attributes.

rule_id

string

Rule id is an identifier used for identifying the rule

rule_name

string

Name assigned to a particular rule.

rollout_percentage

integer

Rollout percentage associated with feature flag. Supported only for Lite and Enterprise plans.

rollout_type

string

The rollout strategy type for the feature flag. `MANUAL` is the default. `PROGRESSIVE` enables automatic phase-based rollout. `GUARDED` enables automatic phase-based rollout that is monitored against the configured metrics.

rollout_configuration

RolloutConfiguration

Configuration that controls the rollout behaviour for a Progressive or Guarded rollout type.

order

integer

Order of the rule, used during evaluation. The evaluation is performed in the order defined and the value associated with the first matching rule is used for evaluation.

href

string

Feature flag rule URL

202 - Accepted. Workflow approval initiated for stopping the feature rule rollout operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature rule stop rollout operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

Update Feature rule order

PATCH /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/rules_order

Update Feature rule order.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.features-rules-order.patch

Auditing

Calling this method generates the following auditing event.

  • apprapp.features-rules-order.patch

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

Response

200 - Successfully update the specified feature rule.

202 - Accepted. Workflow approval initiated for the feature rule order operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the feature id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Feature rule order operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

List Guarded Rollouts

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/guarded-rollouts

List all the guarded rollouts for the specified feature flag in the given environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.rollouts.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.rollouts.list

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

Query Parameters

limit

integer

The number of records to retrieve. By default, the list operation return the first 10 records. To retrieve different set of records, use `limit` with `offset` to page through the available records.

offset

integer

The number of records to skip. By specifying `offset`, you retrieve a subset of items that starts with the `offset` value. Use `offset` with `limit` to page through the available records.

Response

200 - Successfully listed all the guarded rollouts for the feature.

guarded_rollouts

array

Array of guarded rollouts.

limit

integer

The number of records that are retrieved in a list.

offset

integer

The number of records that are skipped in a list.

total_count

integer

The total number of records.

first

PaginatedListFirst

URL to navigate to the first page of records.

previous

PaginatedListPrevious

URL to navigate to the previous list of records.

next

PaginatedListNext

URL to navigate to the next list of records.

last

PaginatedListLast

URL to navigate to the last page of records.

400 - Bad Request. The server request does not contain proper values to complete the API request.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

401 - Unauthorized. The request could not be authorized.

message

string

The message describing the error.

404 - Not Found. Verify that the feature_id and environment_id are correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get Guarded Rollout

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/guarded-rollouts/{rollout_id}

Get the details of a specific guarded rollout for a feature flag.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.rollouts.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.rollouts.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

rollout_id

Required *

string

Guarded rollout Id

Query Parameters

Response

200 - Successfully retrieved the guarded rollout details.

rollout_id

string

The unique identifier of the guarded rollout.

rule_id

string

The rule identifier associated with this guarded rollout.

rule

FeatureSegmentRule

start_time

string

The date and time the guarded rollout was started.

end_time

string

The date and time the guarded rollout completed. Null if still in progress.

status

string

The current status of the guarded rollout.

description

string

A human-readable description of the rollout outcome.

current_phase_index

integer

The index of the current or last active phase.

phases

array

Ordered list of rollout phases.

feature_snapshot

GuardedRolloutFeatureSnapshot

Snapshot of feature flag values at the time of the guarded rollout.

metrics

array

Metrics monitored during the guarded rollout.

400 - Bad Request. The server request does not contain proper values to complete the API request.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

401 - Unauthorized. The request could not be authorized.

message

string

The message describing the error.

404 - Not Found. Verify that the rollout_id, feature_id and environment_id are correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get Guarded Rollout Metric

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/features/{feature_id}/guarded-rollouts/{rollout_id}/metrics/{metric_id}

Get the metric details and statistical results for a specific metric of a guarded rollout.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.rollout-metric-timeseries.read

Auditing

Calling this method generates the following auditing event.

  • apprapp.rollout-metric-timeseries.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

feature_id

Required *

string

Feature Id

rollout_id

Required *

string

Guarded rollout Id

metric_id

Required *

string

Metric ID

Query Parameters

Response

200 - Successfully retrieved the guarded rollout metric details.

rollout_id

string

The unique identifier of the guarded rollout.

metric_id

string

The unique identifier of the metric.

status

string

The status of the guarded rollout metric.

sub_status

string

The sub-status indicating the specific state of the guarded rollout metric.

result

array

Time-series statistical results for this metric.

400 - Bad Request. The rollout_id or metric_id path parameter is empty.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

401 - Unauthorized. The request could not be authorized.

message

string

The message describing the error.

404 - Not Found. Verify that the metric_id, rollout_id, feature_id and environment_id are correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get list of Properties

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/properties

List all the properties in the specified environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.properties.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.properties.list

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

Query Parameters

expand

boolean

If set to `true`, returns expanded view of the resource details.

sort

string

Sort the property details based on the specified attribute. By default, items are sorted by name.

tags

string

Filter the resources to be returned based on the associated tags. Specify the parameter as a list of comma separated tags. Returns resources associated with any of the specified tags.

collections

array

Filter properties by a list of comma separated collections.

segments

array

Filter properties by a list of comma separated segments.

include

array

Include the associated collections or targeting rules details in the response.

limit

integer

The number of records to retrieve. By default, the list operation return the first 10 records. To retrieve different set of records, use `limit` with `offset` to page through the available records.

offset

integer

The number of records to skip. By specifying `offset`, you retrieve a subset of items that starts with the `offset` value. Use `offset` with `limit` to page through the available records.

search

string

Searches for the provided keyword and returns the appropriate row with that value. Here the search happens on the '[Name OR Tag]' of the entity

Response

200 - Successfully listed all the properties.

properties

array

Array of properties.

limit

integer

The number of records that are retrieved in a list.

offset

integer

The number of records that are skipped in a list.

total_count

integer

The total number of records.

first

PaginatedListFirst

URL to navigate to the first page of records.

previous

PaginatedListPrevious

URL to navigate to the previous list of records.

next

PaginatedListNext

URL to navigate to the next list of records.

last

PaginatedListLast

URL to navigate to the last page of records.

401 - Unauthorized

message

string

The message describing the error.

Create Property

POST /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/properties

Create a Property

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.properties.create

Auditing

Calling this method generates the following auditing event.

  • apprapp.properties.create

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

Query Parameters

Response

201 - Successfully created the property.

name

string

Property name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

property_id

string

Property id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Property description

type

string

Type of the property (BOOLEAN, STRING, NUMERIC, SECRETREF). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the property (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN`, `NUMERIC` or `SECRETREF` types. This attribute is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN`, `NUMERIC` and `SECRETREF` types.

value

object

Value of the Property. The value can be Boolean, Numeric, SecretRef, String - TEXT, String - JSON, String - YAML as per the `type` and `format` attributes.

tags

string

Tags associated with the property, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different property values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the property.

collections

array

List of collection id representing the collections that are associated with the specified property.

created_time

string

Creation time of the property.

updated_time

string

Last modified time of the property data.

evaluation_time

string

The last occurrence of the property value evaluation.

href

string

Property URL.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Update Property

PUT /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/properties/{property_id}

Update a Property.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.properties.update

Auditing

Calling this method generates the following auditing event.

  • apprapp.properties.update

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

property_id

Required *

string

Property Id

Query Parameters

Response

200 - Successfully updated the property details.

name

string

Property name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

property_id

string

Property id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Property description

type

string

Type of the property (BOOLEAN, STRING, NUMERIC, SECRETREF). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the property (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN`, `NUMERIC` or `SECRETREF` types. This attribute is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN`, `NUMERIC` and `SECRETREF` types.

value

object

Value of the Property. The value can be Boolean, Numeric, SecretRef, String - TEXT, String - JSON, String - YAML as per the `type` and `format` attributes.

tags

string

Tags associated with the property, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different property values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the property.

collections

array

List of collection id representing the collections that are associated with the specified property.

created_time

string

Creation time of the property.

updated_time

string

Last modified time of the property data.

evaluation_time

string

The last occurrence of the property value evaluation.

href

string

Property URL.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

202 - Accepted. Workflow approval initiated for the property update operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the property id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Property update operation is already under workflow approval, or the update is blocked because the property's collection association is being changed from an environment that is not scoped for workflow, while another environment in the instance has an active workflow scope for this property.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Update Property values

PATCH /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/properties/{property_id}

Update the property values. This method can be executed by the `writer` role. Property value and targeting rules can be updated, however this method does not allow assigning property to a collection.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.properties.patch

Auditing

Calling this method generates the following auditing event.

  • apprapp.properties.updatevalues

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

property_id

Required *

string

Property Id

Query Parameters

Response

200 - Successfully updated the property values.

name

string

Property name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

property_id

string

Property id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Property description

type

string

Type of the property (BOOLEAN, STRING, NUMERIC, SECRETREF). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the property (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN`, `NUMERIC` or `SECRETREF` types. This attribute is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN`, `NUMERIC` and `SECRETREF` types.

value

object

Value of the Property. The value can be Boolean, Numeric, SecretRef, String - TEXT, String - JSON, String - YAML as per the `type` and `format` attributes.

tags

string

Tags associated with the property, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different property values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the property.

collections

array

List of collection id representing the collections that are associated with the specified property.

created_time

string

Creation time of the property.

updated_time

string

Last modified time of the property data.

evaluation_time

string

The last occurrence of the property value evaluation.

href

string

Property URL.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

202 - Accepted. Workflow approval initiated for the property patch operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the property id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Property patch operation is already under workflow approval.

message

string

Message describing the conflict. Format varies by resource type and operation.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get Property

GET /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/properties/{property_id}

Retrieve details of a property.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.properties.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.properties.read

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

property_id

Required *

string

Property Id

Query Parameters

include

array

Include the associated collections or targeting rules details in the response.

Response

200 - Successfully retrieved the property details.

name

string

Property name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

property_id

string

Property id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Property description

type

string

Type of the property (BOOLEAN, STRING, NUMERIC, SECRETREF). If `type` is `STRING`, then `format` attribute is required.

format

string

Format of the property (TEXT, JSON, YAML) and it is a required attribute when `type` is `STRING`. It is not required for `BOOLEAN`, `NUMERIC` or `SECRETREF` types. This attribute is populated in the response body of `POST, PUT and GET` calls if the type `STRING` is used and not populated for `BOOLEAN`, `NUMERIC` and `SECRETREF` types.

value

object

Value of the Property. The value can be Boolean, Numeric, SecretRef, String - TEXT, String - JSON, String - YAML as per the `type` and `format` attributes.

tags

string

Tags associated with the property, allowed special characters are [_. ,-:]

segment_rules

array

Specify the targeting rules that is used to set different property values for different segments.

segment_exists

boolean

Denotes if the targeting rules are specified for the property.

collections

array

List of collection id representing the collections that are associated with the specified property.

created_time

string

Creation time of the property.

updated_time

string

Last modified time of the property data.

evaluation_time

string

The last occurrence of the property value evaluation.

href

string

Property URL.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

404 - Not Found. Verify that the property id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Delete Property

DELETE /apprapp/feature/v1/instances/{guid}/environments/{environment_id}/properties/{property_id}

Delete a Property

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.properties.delete

Auditing

Calling this method generates the following auditing event.

  • apprapp.properties.delete

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

environment_id

Required *

string

Environment Id

property_id

Required *

string

Property Id

Query Parameters

Response

202 - Accepted. Workflow approval initiated for the property delete operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

204 - Successfully deleted the specified property

404 - Not Found. Verify that the property id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

409 - Conflict. Property delete operation is already under workflow approval, or the delete is blocked because the property is being deleted from an environment that is not scoped for workflow, while another environment in the instance has an active workflow scope for this property.

501 - Not Implemented.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Get list of Segments

GET /apprapp/feature/v1/instances/{guid}/segments

List all the segments

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.segments.list

Auditing

Calling this method generates the following auditing event.

  • apprapp.segments.list

Request

Path Parameters

guid

Required *

string

AppConfiguration instance Id

Query Parameters

expand

boolean

If set to `true`, returns expanded view of the resource details.

sort

string

Sort the segment details based on the specified attribute. By default, items are sorted by name.

tags

string

Filter the resources to be returned based on the associated tags. Specify the parameter as a list of comma separated tags. Returns resources associated with any of the specified tags.

include

array

Segment details to include the associated rules in the response.

limit

integer

The number of records to retrieve. By default, the list operation return the first 10 records. To retrieve different set of records, use `limit` with `offset` to page through the available records.

offset

integer

The number of records to skip. By specifying `offset`, you retrieve a subset of items that starts with the `offset` value. Use `offset` with `limit` to page through the available records.

search

string

Searches for the provided keyword and returns the appropriate row with that value. Here the search happens on the '[Name OR Tag]' of the entity

Response

200 - Successfully listed all the segments.

segments

array

Array of Segments.

limit

integer

The number of records that are retrieved in a list.

offset

integer

The number of records that are skipped in a list.

total_count

integer

The total number of records.

first

PaginatedListFirst

URL to navigate to the first page of records.

previous

PaginatedListPrevious

URL to navigate to the previous list of records.

next

PaginatedListNext

URL to navigate to the next list of records.

last

PaginatedListLast

URL to navigate to the last page of records.

401 - Unauthorized

message

string

The message describing the error.

Create Segment

POST /apprapp/feature/v1/instances/{guid}/segments

Create a segment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.segments.create

Auditing

Calling this method generates the following auditing event.

  • apprapp.segments.create

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

Query Parameters

Response

201 - Successfully created the segment

name

string

Segment name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

segment_id

string

Segment id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Segment description

tags

string

Tags associated with the segments, allowed special characters are [_. ,-:]

rules

array

List of rules that determine if the entity belongs to the segment during feature / property evaluation. An entity is identified by an unique identifier and the attributes that it defines. Any feature flag and property value evaluation is performed in the context of an entity when it is targeted to segments.

created_time

string

Creation time of the segment.

updated_time

string

Last modified time of the segment data.

href

string

Segment URL.

features

array

List of Features associated with the segment.

properties

array

List of properties associated with the segment.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

Update Segment

PUT /apprapp/feature/v1/instances/{guid}/segments/{segment_id}

Update the segment properties

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • apprapp.segments.update

Auditing

Calling this method generates the following auditing event.

  • apprapp.segments.update

Request

Request Body

Path Parameters

guid

Required *

string

AppConfiguration instance Id

segment_id

Required *

string

Segment Id

Query Parameters

Response

200 - Successfully updated the segment details.

name

string

Segment name. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

segment_id

string

Segment id. Allowed special characters are dot ( . ), hyphen( - ), underscore ( _ ) only

description

string

Segment description

tags

string

Tags associated with the segments, allowed special characters are [_. ,-:]

rules

array

List of rules that determine if the entity belongs to the segment during feature / property evaluation. An entity is identified by an unique identifier and the attributes that it defines. Any feature flag and property value evaluation is performed in the context of an entity when it is targeted to segments.

created_time

string

Creation time of the segment.

updated_time

string

Last modified time of the segment data.

href

string

Segment URL.

features

array

List of Features associated with the segment.

properties

array

List of properties associated with the segment.

workflow_approval

WorkflowApprovalInfo

Workflow approval information attached to a resource when it's under approval. This field is only present when workflow is enabled and the resource has an active change request.

202 - Accepted. Workflow approval initiated for the segment update operation.

message

string

Message describing the workflow approval initiation. Message varies based on resource type and operation.

workflow_approval

WorkflowApprovalDetails

Details of the workflow approval.

400 - Bad request. Verify that the information in the request body is complete and correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

404 - Not Found. Verify that the segment id is correct.

code

string

The error code returned by the server.

message

string

The message describing the error.

trace

string

The unique transaction identifier of the request, which can be shared with IBM support for troubleshooting.

[...]
